<script lang="ts" setup>
  import { ProductListingEventEnum } from '~/components/presentation/model';

  const emits = defineEmits<{
    (e: 'trigger', event: ProductListingEventEnum, options?: any): void;
  }>();

  defineProps<{
    loading?: boolean;
  }>();
  const { goTo, currentSlideIndex } = usePresentation();
  const { listingSlides } = useProductListing();
</script>

<template>
  <Teleport to="#left-sidebar">
    <SwSidebar :loading="loading" class="absolute left-0 top-0" :show-close-btn="false">
      <template #header>
        <div class="flex w-full flex-col gap-5">
          <div class="flex items-center justify-between">
            <SwButton
              variant="action"
              class="!p-2"
              @click="$emit('trigger', ProductListingEventEnum.GO_BACK)"
            >
              <span class="i-sw-solid:chevron-circle-left text-base" />
            </SwButton>

            <p class="line-clamp-1 px-2.5 text-lg font-bold">
              {{ $t('listing.productListing') }}
            </p>

            <SwButton
              variant="action"
              class="!p-2"
              @click="$emit('trigger', ProductListingEventEnum.CLOSE_PRODUCT_LISTING_LAYER)"
            >
              <span class="i-sw-solid:times-circle text-base" />
            </SwButton>
          </div>

          <SwButton
            v-if="listingSlides.length"
            @click="emits('trigger', ProductListingEventEnum.OPEN_PRODUCT_SELECTION_SIDEBAR)"
          >
            {{ $t('listing.create') }}
          </SwButton>
        </div>
      </template>

      <template #body>
        <div class="relative h-full divide-y px-6 py-2">
          <template v-if="listingSlides.length">
            <div
              v-for="item of listingSlides"
              :key="item.cmsPageId"
              class="flex flex-col gap-2 py-4"
            >
              <p class="line-clamp-2 text-sm font-bold">
                {{ item.groupName || `${$t('presentation.slide')} ${item.index}` }}
              </p>

              <p
                v-if="item.pickedProductsCount !== undefined"
                class="text-information-subdued text-sm font-medium lowercase"
              >
                <span>{{ item.pickedProductsCount + ' ' }}</span>
                <span>
                  {{
                    item.pickedProductsCount > 1 ? $t('product.products') : $t('product.product')
                  }}</span
                >
              </p>

              <div class="flex items-center justify-between">
                <div>
                  <SwButton
                    class="flex items-center gap-1.5"
                    @click="
                      emits('trigger', ProductListingEventEnum.OPEN_PRODUCT_SELECTION_SIDEBAR, {
                        slideIndex: item.index - 1,
                      })
                    "
                  >
                    <span class="i-sw-solid:pencil-s text-sm" />
                    <span>{{ $t('edit') }}</span>
                  </SwButton>
                </div>
                <SwButton
                  variant="action"
                  class="flex items-center gap-1.5"
                  :disabled="item.index === currentSlideIndex"
                  @click="goTo(item.index)"
                >
                  <span>{{ $t('listing.goToListing') }}</span>
                  <span class="i-sw-solid:long-arrow-right text-sm" />
                </SwButton>
              </div>
            </div>
          </template>

          <div v-else class="flex h-full flex-col items-center justify-center gap-4 text-center">
            <div class="rounded-full bg-gray-50 p-6">
              <span class="i-sw-solid:list text-information-subdued h-6 w-6" />
            </div>
            <span class="font-semibold">{{ $t('listing.messages.noListCreated') }}</span>
            <span class="text-information-subdued text-sm">
              {{ $t('listing.messages.createNew') }}
            </span>
            <SwButton
              @click="emits('trigger', ProductListingEventEnum.OPEN_PRODUCT_SELECTION_SIDEBAR)"
            >
              {{ $t('listing.create') }}
            </SwButton>
          </div>
        </div>
      </template>
      <template #footer>
        <SlideNotes />
      </template>
    </SwSidebar>
  </Teleport>
</template>
